// 2Patient.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "2Patient.h"

#include "MainFrm.h"
#include "2PatientDoc.h"
#include "2PatientView.h"

#include "OptionsDialog.h"

#include "Engine/GameModel.h"

#include "Engine/logging.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// C2PatientApp

BEGIN_MESSAGE_MAP(C2PatientApp, CWinApp)
	//{{AFX_MSG_MAP(C2PatientApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPTIONS, OnFileOptions)
	ON_THREAD_MESSAGE(WM_TIMER, OnTimer)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_UNDO, OnFileUndo)
	ON_COMMAND(ID_FILE_REDO, OnFileRedo)
	ON_UPDATE_COMMAND_UI(ID_FILE_UNDO, OnUpdateFileUndo)
	ON_UPDATE_COMMAND_UI(ID_FILE_REDO, OnUpdateFileRedo)
	//}}AFX_MSG_MAP
	// Standard file based document commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C2PatientApp construction

C2PatientApp::C2PatientApp() /*: iSentStateChangeMessage(false)*/
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only C2PatientApp object

C2PatientApp theApp;

/////////////////////////////////////////////////////////////////////////////
// C2PatientApp initialization

BOOL C2PatientApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("i42 Software"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(C2PatientDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(C2PatientView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	if (m_pMainWnd == 0)
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());
	CGameState& state = static_cast<CGameState&>(pDoc->Model());
	state.AddObserver(*this);

	iTimer = SetTimer(NULL, 0, 10, NULL);

/*	::PostThreadMessage(GetCurrentThreadId(), WM_STATECHANGE, 0, 0);*/

	return TRUE;
}

BOOL C2PatientApp::OnIdle(LONG lCount)
{
	return CWinApp::OnIdle(lCount);
}

void C2PatientApp::OnSetGameState(CGameModel& aModel, EGameState aNewState)
{
/*	if (iSentStateChangeMessage)
		return;

	::PostThreadMessage(GetCurrentThreadId(), WM_STATECHANGE, 0, 0);

	iSentStateChangeMessage = true;*/
}

/*void C2PatientApp::OnStateChangeMessage(WPARAM aWparam, LPARAM aLparam)
{
	iSentStateChangeMessage = false;
}*/

void C2PatientApp::OnTimer(WPARAM wParam, LPARAM lParam)
{
	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());
	CGameState& state = static_cast<CGameState&>(pDoc->Model());

	if (!iModalDialog)
		if (state.NeedNotification())
			state.NotifyObserversStateChanged();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void C2PatientApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	iModalDialog = true;
	aboutDlg.DoModal();
	iModalDialog = false;
}

/////////////////////////////////////////////////////////////////////////////
// C2PatientApp message handlers

void C2PatientApp::OnFileOptions() 
{
	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());

	COptionsDialog optionsDlg(pDoc->Model());
	iModalDialog = true;
	optionsDlg.DoModal();
	iModalDialog = false;
}

void C2PatientApp::OnFileUndo() 
{
	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());
	pDoc->Model().UndoMove();
}

void C2PatientApp::OnFileRedo() 
{
	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());
	pDoc->Model().RedoMove();
}

void C2PatientApp::OnUpdateFileUndo(CCmdUI* pCmdUI) 
{
	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());
	pCmdUI->Enable(pDoc->Model().CanUndoMove());
}

void C2PatientApp::OnUpdateFileRedo(CCmdUI* pCmdUI) 
{
	C2PatientDoc* pDoc = static_cast<C2PatientDoc*>(static_cast<CFrameWnd*>(m_pMainWnd)->GetActiveDocument());
	pCmdUI->Enable(pDoc->Model().CanRedoMove());
}
