// 2PatientDoc.cpp : implementation of the C2PatientDoc class
//

#include "stdafx.h"
#include "2Patient.h"

#include "2PatientDoc.h"

#include "Engine/GameModel.h"
#include "Engine/Base64.h"
#include "GameCardRenderer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// C2PatientDoc

IMPLEMENT_DYNCREATE(C2PatientDoc, CDocument)

BEGIN_MESSAGE_MAP(C2PatientDoc, CDocument)
	//{{AFX_MSG_MAP(C2PatientDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C2PatientDoc construction/destruction

C2PatientDoc::C2PatientDoc() : 
	iGameModel(0), iGameCardRenderer(0)
{
	// TODO: workout best place for this for 2-stage construction

	iGameModel = new CGameModel();
	static_cast<IGameObject*>(iGameModel)->InitResources();

	iGameCardRenderer = new CGameCardRenderer(*iGameModel);
	iGameCardRenderer->InitResources();

	iGameModel->AddObserver(*this);
}

C2PatientDoc::~C2PatientDoc()
{
	delete iGameModel;
	delete iGameCardRenderer;
}

BOOL C2PatientDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	static_cast<IGameObject*>(iGameModel)->NewGame(iGameModel->NumberOfPlayersNextGame());

	m_bModified = FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// C2PatientDoc serialization

void C2PatientDoc::Serialize(CArchive& ar)
{
	unsigned char srcBuffer[160], destBuffer[160];
	unsigned char* srcBufferPtr = srcBuffer;
	int srcBufferBytesLeft = 160;

	if (ar.IsStoring())
	{
		if (!static_cast<ISerializable*>(iGameModel)->SerializeOut(srcBufferPtr, srcBufferBytesLeft))
			return;

		Base64::Buffer src64Buffer(srcBuffer, 160 - srcBufferBytesLeft, 160);
		Base64::Buffer dest64Buffer(destBuffer, 0, 160);
		Base64::Encode(src64Buffer, dest64Buffer);

		ar.Write(dest64Buffer.iPtr, dest64Buffer.iMaxLength);

		unsigned char testBuffer[160];
		src64Buffer.iPtr = testBuffer;
		Base64::Decode(dest64Buffer, src64Buffer);
	}
	else
	{
		ar.Read(srcBuffer, 160);

		Base64::Buffer src64Buffer(srcBuffer, 160, 160);
		Base64::Buffer dest64Buffer(destBuffer, 0, 160);
		Base64::Decode(src64Buffer, dest64Buffer);

		if (!static_cast<ISerializable*>(iGameModel)->SerializeIn(dest64Buffer.iPtr, dest64Buffer.iLength))
			return;
	}
}

/////////////////////////////////////////////////////////////////////////////
// C2PatientDoc diagnostics

#ifdef _DEBUG
void C2PatientDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void C2PatientDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// C2PatientDoc commands

void C2PatientDoc::OnGameStateChanged(CGameModel& aModel, EGameState aOldState, EGameState aNewState)
{
	m_bModified = TRUE;

	UpdateAllViews(NULL);
}