// 2PatientDoc.h : interface of the C2PatientDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_2PatientDOC_H__0C6BE280_7981_4B5A_8DA4_D98A2584E009__INCLUDED_)
#define AFX_2PatientDOC_H__0C6BE280_7981_4B5A_8DA4_D98A2584E009__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Engine/GameState.h"

class CGameModel;
class CGameCardRenderer;

class C2PatientDoc : public CDocument, private IGameStateObserver
{
protected: // create from serialization only
	C2PatientDoc();
	DECLARE_DYNCREATE(C2PatientDoc)

// Attributes
public:
	CGameModel* iGameModel;
	CGameCardRenderer* iGameCardRenderer;

// Operations
public:
	CGameModel& Model() { return *iGameModel; }
	CGameCardRenderer& GameCardRenderer() { return *iGameCardRenderer; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(C2PatientDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~C2PatientDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// from IGameStateObserver
	virtual void OnSetGameState(CGameModel& aModel, EGameState aNewState) {}
	virtual void OnGameStateChanged(CGameModel& aModel, EGameState aOldState, EGameState aNewState);

// Generated message map functions
protected:
	//{{AFX_MSG(C2PatientDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_2PatientDOC_H__0C6BE280_7981_4B5A_8DA4_D98A2584E009__INCLUDED_)
