// 2PatientView.h : interface of the C2PatientView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_2PatientVIEW_H__C96954B1_A4E0_4607_8036_80904A572FD3__INCLUDED_)
#define AFX_2PatientVIEW_H__C96954B1_A4E0_4607_8036_80904A572FD3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CGameModel;
class CGameBoard;
class CGameCardRenderer;

#include "Engine/GameBoardRenderer.h"

class C2PatientView : public CView, private IGameBoardRenderer
{
protected: // create from serialization only
	C2PatientView();
	DECLARE_DYNCREATE(C2PatientView)

// Attributes
public:
	C2PatientDoc* GetDocument();
	CDC* iCanvasDC;
	CBitmap* iCanvasBitmap;
	CBitmap* iOldCanvasDCBitmap;

	bool iMovingCards;

	bool iRedrawWindow;
	CRect iRedrawRect;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(C2PatientView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~C2PatientView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

private:
	void UpdateSpacialInformation();

// Generated message map functions
protected:
	//{{AFX_MSG(C2PatientView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// from IGameBoardRenderer 
	virtual void RenderGameBoard(const SSpacialInformation& aRect);
};

#ifndef _DEBUG  // debug version in 2PatientView.cpp
inline C2PatientDoc* C2PatientView::GetDocument()
   { return (C2PatientDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_2PatientVIEW_H__C96954B1_A4E0_4607_8036_80904A572FD3__INCLUDED_)
