#include "Base64.h"


bool Base64::Encode(Buffer& aSrcBuffer, Buffer& aDestBuffer)
{
	aDestBuffer.iLength = 0;

	for (int inbyte = 0; inbyte < aSrcBuffer.iLength; inbyte += 3)
	{
		unsigned char dch[3];
		dch[0] = inbyte+0 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+0] : 0;
		dch[1] = inbyte+1 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+1] : 0;
		dch[2] = inbyte+2 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+2] : 0;
	
		unsigned char ech[4];
		ech[0] = (dch[0] & 63) + ' ';
		ech[1] = ((dch[0] & 192) >> 2) + (dch[1] & 15) + ' ';
		ech[2] = ((dch[1] & 240) >> 2) + (dch[2] & 3) + ' ';
		ech[3] = ((dch[2] & 252) >> 2) + ' ';

/*		ech[0] = (dch[0] & 63) + ' ';
		ech[1] = (dch[1] & 63) + ' '; 
		ech[2] = (dch[2] & 63) + ' ';
		ech[3] = ((dch[0] & 192) >> 6) + ((dch[1] & 192) >> 4) + ((dch[2] & 192) >> 2) + ' ';
*/
		for (int outbyte = 0; outbyte < 4 && aDestBuffer.iLength < aDestBuffer.iMaxLength; ++outbyte)
		{
			aDestBuffer.iPtr[aDestBuffer.iLength++] = ech[outbyte];
		}
	}

	return true;
}

bool Base64::Decode(Buffer& aSrcBuffer, Buffer& aDestBuffer)
{
	aDestBuffer.iLength = 0;

	for (int inbyte = 0; inbyte < aSrcBuffer.iLength; inbyte += 4)
	{
		unsigned char ech[4];
		ech[0] = inbyte+0 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+0] - ' ' : 0;
		ech[1] = inbyte+1 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+1] - ' ' : 0;
		ech[2] = inbyte+2 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+2] - ' ' : 0;
		ech[3] = inbyte+3 < aSrcBuffer.iLength ? aSrcBuffer.iPtr[inbyte+3] - ' ' : 0;
		
		unsigned char dch[3];
		dch[0] = (ech[0] & 63) + ((ech[1] << 2) & 192);
		dch[1] = (ech[1] & 15) + ((ech[2] << 2) & 240);
		dch[2] = (ech[2] & 3) + ((ech[3] << 2) & 252);

/*		dch[0] = ech[0] + (192 & (ech[3] << 6));
		dch[1] = ech[1] + (192 & (ech[3] << 4));
		dch[2] = ech[2] + (192 & (ech[3] << 2));
*/
		for (int outbyte = 0; outbyte < 3 && aDestBuffer.iLength < aDestBuffer.iMaxLength; ++outbyte)
		{
			aDestBuffer.iPtr[aDestBuffer.iLength++] = dch[outbyte];
		}
	}

	return true;
}


