// GameCard.cpp : implementation file
//

#include "GameCard.h"

/////////////////////////////////////////////////////////////////////////////
// CGameCard

CGameCard::CGameCard(ECardValue aValue, ECardSuit aSuit) : 
	iValue(aValue), iSuit(aSuit), iFaceDown(false), iDealt(false)
{
}

CGameCard::~CGameCard()
{
}

void CGameCard::Swap(CGameCard& aOtherCard)
{
	ECardValue tmpValue(aOtherCard.Value());
	ECardSuit tmpSuit(aOtherCard.Suit());
	bool tmpFaceDown(aOtherCard.FaceDown());
	bool tmpDealt(aOtherCard.Dealt());

	aOtherCard.SetValue(Value());
	aOtherCard.SetSuit(Suit());
	aOtherCard.SetFaceDown(FaceDown());
	aOtherCard.SetDealt(Dealt());

	SetValue(tmpValue);
	SetSuit(tmpSuit);
	SetFaceDown(tmpFaceDown);
	SetDealt(tmpDealt);
}

#ifdef OS_SYMBIAN
void CGameCard::ConstructL()
{
}
#else // not OS_SYMBIAN
bool CGameCard::InitResources()
{
	return true;
}
#endif

void CGameCard::NewGame(int /*aNumberOfPlayers*/)
{
	SetFaceDown(true);
	SetDealt(false);
}

bool CGameCard::SerializeIn(const unsigned char*& aBufferPtr, int& aBufferBytesLeft)
{
	if (aBufferBytesLeft < 1)
		return false;
	unsigned char ch = *aBufferPtr++;
	--aBufferBytesLeft;
	if (ch & 128)
		SetFaceDown(true);
	else
		SetFaceDown(false);
	ch &= ~128;
	iSuit = static_cast<ECardSuit>((ch / 13) % 4);
	iValue = static_cast<ECardValue>(ch % 13);

	return true;
}

bool CGameCard::SerializeOut(unsigned char*& aBufferPtr, int& aBufferBytesLeft) const
{
	if (aBufferBytesLeft < 1)
		return false;
	unsigned char ch = (iSuit * 13 + iValue) % 256;
	if (iFaceDown)
		ch = ch | 128;
	*aBufferPtr++ = ch;
	--aBufferBytesLeft;

	return true;
}

void CGameCard::SpacialInformation(int& aXPosition, int& aYPosition, int& aWidth, int& aHeight) const
{
	SSpacialInformation::SpacialInformation(aXPosition, aYPosition, aWidth, aHeight);
}

void CGameCard::SetSpacialInformation(int aXPosition, int aYPosition, int aWidth, int aHeight)
{
	SSpacialInformation::SetSpacialInformation(aXPosition, aYPosition, aWidth, aHeight);
}
