#if !defined(GameObject_H_Included)
#define GameObject_H_Included

#include "options.h"

#ifdef OS_SYMBIAN
#include <e32base.h>
#endif

// GameObject.h : header file
//

#include "Serializable.h"

struct IGameObject
{
#ifdef OS_SYMBIAN
	virtual void ConstructL() = 0;
#else // OS_WINDOWS
	virtual bool InitResources() = 0;
#endif
	virtual void NewGame(int aNumberOfPlayers) = 0; // 0, 1 or 2 players
};

#ifdef OS_SYMBIAN
class CGameObject : public CBase, public IGameObject, public ISerializable
#else // OS_WINDOWS
class CGameObject : public IGameObject, public ISerializable
#endif
{
// Construction
public:
	CGameObject();
	virtual ~CGameObject();
};

/////////////////////////////////////////////////////////////////////////////

#endif // !defined(GameObject_H_Included)
