#if !defined(GamePlayer_H_Included)
#define GamePlayer_H_Included

// GamePlayer.h : header file
//

#include "GameCommon.h"
#include "GameState.h"

class CGameModel;
class CGameCardStack;

class CGamePlayer : public CGameObject, private IGameStateObserver
{
// Construction
public:
	CGamePlayer(CGameModel& aModel, int aPlayerNumber);
	~CGamePlayer();

// Attributes
private:
	CGameModel& iGameModel;
	int iPlayerNumber;
	bool iComputerPlayer;
	int iTrySrcStackCardIndex;
	int iTrySrcStackIndex;
	int iTryTargetStackIndex;
	bool iIncrTargetStackIndex;
	bool iAnotherRound;

// Operations
public:
	bool ComputerPlayer() const { return iComputerPlayer; }

// Implementation
private:
// from CGameObject
#ifdef OS_SYMBIAN
	virtual void ConstructL();
#else // OS_WINDOWS
	virtual bool InitResources();
#endif	
	virtual void NewGame(int aNumberOfPlayers);
	virtual bool SerializeIn(const unsigned char*& aBufferPtr, int& aBufferBytesLeft);
	virtual bool SerializeOut(unsigned char*& aBufferPtr, int& aBufferBytesLeft) const;
// from IGameStateObserver
	virtual void OnSetGameState(CGameModel& /*aModel*/, EGameState /*aNewState*/) {}
	virtual void OnGameStateChanged(CGameModel& aModel, EGameState aOldState, EGameState aNewState);
};

/////////////////////////////////////////////////////////////////////////////

#endif // !defined(GamePlayer_H_INCLUDED)
