#include "GameState.h"
#include "logging.h"

void CGameState::SetGameState(EGameState aNewState)
{
	if (iGameState == aNewState)
		return;
	iGameStatePrevious = iGameState;
	iGameState = aNewState;
	iNotifyObserversStateChanged = true;
	NotifyObserversSetState();
}

void CGameState::NotifyObserversSetState()
{
	for (int i = iObserverCount - 1; i >= 0; --i)
	{
		iObservers[(iObserverCount - 1) - i]->OnSetGameState(iModel, iGameState);
	}
}

bool CGameState::NeedNotification() const 
{ 
	return iNotifyObserversStateChanged; 
}

void CGameState::NotifyObserversStateChanged()
{
	EGameState currentState = iGameState;
	EGameState previousState = iGameStatePrevious;
	iNotifyObserversStateChanged = false;
	for (int i = iObserverCount - 1; i >= 0; --i)
	{
		iObservers[(iObserverCount - 1) - i]->OnGameStateChanged(iModel, iGameStatePrevious, iGameState);
	}
}

void CGameState::AddObserver(IGameStateObserver& aObserver)
{
	iObservers[iObserverCount++] = &aObserver;
	aObserver.OnGameStateChanged(iModel, iGameStatePrevious, iGameState);
}

void CGameState::RemoveObserver(IGameStateObserver& aObserver)
{
	for (int i = 0; i < iObserverCount; ++i)
	{
		if (iObservers[i] == &aObserver)
		{
			iObservers[i] = 0;
			for (int j = i+1; j <  iObserverCount; ++j)
			{
				iObservers[j-1] = iObservers[j];
			}
			break;
		}
	}
	--iObserverCount;
}
