#if !defined(SpacialInformation_H_Included)
#define SpacialInformation_H_Included

// SpacialInformation.h : header file
//

#include "lib/algorithm.h"

struct ISpacialInformation
{
	virtual void SpacialInformation(int& aX, int& aY, int& aWidth, int& aHeight) const = 0;
	virtual void SetSpacialInformation(int aX, int aY, int aWidth, int aHeight) = 0;
	virtual bool PointIntersects(int aX, int aY) const = 0;
	virtual bool RectIntersects(int aX1, int aY1, int aX2, int aY2) const = 0; 
};

struct SSpacialInformation : ISpacialInformation
{
// Construction
	SSpacialInformation() : iX(0), iY(0), iWidth(0), iHeight(0) {}
	SSpacialInformation(int aX, int aY, int aWidth, int aHeight) :
	iX(aX), iY(aY), iWidth(aWidth), iHeight(aHeight) {}
	virtual ~SSpacialInformation() {}

// Attributes
	int iX;
	int iY;
	int iWidth;
	int iHeight;

// Operations
	virtual void SpacialInformation(int& aX, int& aY, int& aWidth, int& aHeight) const
	{
		aX = iX;
		aY = iY;
		aWidth = iWidth;
		aHeight = iHeight;
	}

	virtual void SetSpacialInformation(int aX, int aY, int aWidth, int aHeight)
	{
		iX = aX;
		iY = aY;
		iWidth = aWidth;
		iHeight = aHeight;
	}

	virtual bool PointIntersects(int aX, int aY) const
	{
		if (aX < iX)
			return false;
		if (aY < iY)
			return false;
		if (aX >= iX + iWidth)
			return false;
		if (aY >= iY + iHeight)
			return false;
		return true;
	}
	
	virtual bool RectIntersects(int aX1, int aY1, int aX2, int aY2) const
	{
		return lib::min(aX2, iX + iWidth - 1) >= lib::max(aX1, iX) &&
			lib::min(aY2, iY + iHeight - 1) >= lib::max(aY1, iY);
	}
};

/////////////////////////////////////////////////////////////////////////////

#endif // !defined(SpacialInformation_H_Included)
