// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__2089C17E_14C1_4AB1_8F47_FA7938ADFD40__INCLUDED_)
#define AFX_MAINFRM_H__2089C17E_14C1_4AB1_8F47_FA7938ADFD40__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Engine/GameState.h"

class CGameModel;

class CMainFrame : public CFrameWnd, private IGameStateObserver
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	CString m_strStatusTexts[13];
	int m_nCurrentStatus;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual void GetMessageString(UINT nID, CString& rMessage) const;
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
private:
	// from IGameStateObserver
	virtual void OnSetGameState(CGameModel& aModel, EGameState aNewState) {}
	virtual void OnGameStateChanged(CGameModel& aModel, EGameState aOldState, EGameState aNewState);

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__2089C17E_14C1_4AB1_8F47_FA7938ADFD40__INCLUDED_)
