// OptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "2Patient.h"
#include "OptionsDialog.h"

#include "Engine/GameModel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDialog dialog


COptionsDialog::COptionsDialog(CGameModel& aGameModel, CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDialog::IDD, pParent), iGameModel(aGameModel)
{
	//{{AFX_DATA_INIT(COptionsDialog)
	m_nNumberOfPlayers = iGameModel.NumberOfPlayersNextGame();
	m_nNumberOfColumns = iGameModel.NumberOfInStacksNextGame() == 4 ? 0 : 1;
	m_nAllowISOOS = iGameModel.AllowISOOSNextGame() ? TRUE : FALSE;
	m_nCardSpeed = iGameModel.CardSpeed();
	//}}AFX_DATA_INIT
}


void COptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDialog)
	DDX_Control(pDX, IDC_CARDSPEED, m_ctrlCardSpeed);
	DDX_Radio(pDX, IDC_PLAYERS, m_nNumberOfPlayers);
	DDX_Radio(pDX, IDC_COLUMNS, m_nNumberOfColumns);
	DDX_Check(pDX, IDC_ISOOS, m_nAllowISOOS);
	DDX_Slider(pDX, IDC_CARDSPEED, m_nCardSpeed);
	//}}AFX_DATA_MAP

	if (pDX->m_bSaveAndValidate)
	{
		iGameModel.SetNumberOfPlayersNextGame(m_nNumberOfPlayers);
		iGameModel.SetNumberOfInStacksNextGame(m_nNumberOfColumns == 0 ? 4 : 7);
		iGameModel.SetAllowISOOSNextGame(m_nAllowISOOS == TRUE ? true : false);
		iGameModel.SetCardSpeed(m_nCardSpeed);
	}
	else
	{
		m_nCardSpeed = iGameModel.CardSpeed();
		m_ctrlCardSpeed.SetPos(m_nCardSpeed);
		m_ctrlCardSpeed.SetRange(1, 10, TRUE);
	}
}


BEGIN_MESSAGE_MAP(COptionsDialog, CDialog)
	//{{AFX_MSG_MAP(COptionsDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

